using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace billing_starter
{
	/// <summary>
	/// Default is the main form for the billing_starter application
	/// </summary>
	public class Default : System.Web.UI.Page
	{
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.Button showAllButton;
		protected System.Web.UI.WebControls.Button showLastWeekButton;
		protected System.Web.UI.WebControls.PlaceHolder showByItemsError;
		protected System.Web.UI.WebControls.TextBox showByItemsTextBox;
		protected System.Web.UI.WebControls.Button showByItemsButton;
		protected System.Web.UI.WebControls.PlaceHolder showByPackagesError;
		protected System.Web.UI.WebControls.TextBox showByPackagesTextBox;
		protected System.Web.UI.WebControls.Button showByPackagesButton;
		protected System.Web.UI.WebControls.PlaceHolder showByCustomerError;
		protected System.Web.UI.WebControls.TextBox showByCustomerTextBox;
		protected System.Web.UI.WebControls.Button showByCustomerButton;
		protected System.Web.UI.WebControls.PlaceHolder countByCityError;
		protected System.Web.UI.WebControls.TextBox countByCityTextBox;
		protected System.Web.UI.WebControls.Button countByCityButton;
		protected System.Web.UI.WebControls.Repeater results;
		#endregion
	
		/// <summary>
		/// Called when page initially loads 
		/// </summary>
		private void Page_Load(object sender, System.EventArgs e)
		{
			/* ... maybe set up your database connection or something ... */

			// set all error messages to invisible, if there is an error they will be reset
			this.showByCustomerError.Visible = false;
			this.showByItemsError.Visible = false;
			this.showByPackagesError.Visible = false;
			this.countByCityError.Visible = false;

			// If the page is being requested for the first time, show all 
			if(!Page.IsPostBack)
			{
				ShowAll(null, null);
			}
		}

		/// <summary>
		/// Called before the page is rendered
		/// </summary>
		private void Page_PreRender(object sender, System.EventArgs e)
		{
			// When the page is databound, then all 'templates' are filled out and its safe to
			// clean up the business logic
			DataBind();

			/* ... maybe do some cleanup work here ... */
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		/// <summary>
		/// Show all invoices in the database
		/// </summary>
		protected void ShowAll(object sender, System.EventArgs e)
		{
			/* !!! */
		}

		/// <summary>
		/// Show invoices from the last week
		/// </summary>
		protected void ShowLastWeek(object sender, System.EventArgs e)
		{
			/* !!! */
		}

		/// <summary>
		/// Show invoices with more than x items
		/// </summary>
		protected void ShowByItems(object sender, System.EventArgs e)
		{
			int minItems = 0;   
			// validate user input
			try 
			{
				minItems = Int32.Parse(this.showByItemsTextBox.Text);
			} 
			catch (FormatException)
			{
				// user input is invalid, return
				this.showByItemsError.Visible = true;
				return;
			}

			/* !!! */
		}

		/// <summary>
		/// Show invoices with more than x packages
		/// </summary>
		protected void ShowByPackages(object sender, System.EventArgs e)
		{
			int minPackages = 0;

			// validate user input
			try 
			{
				minPackages = Int32.Parse(this.showByPackagesTextBox.Text);
			} 
			catch (FormatException)
			{
				// user input is invalid, return
				this.showByPackagesError.Visible = true;
				return;
			}

			/* !!! */
		}

		/// <summary>
		/// Show invoices that belong to a particular customer
		/// </summary>
		protected void ShowByCustomer(object sender, System.EventArgs e)
		{
			// escape all quotes to prevent SQL injection attack!
			string email = this.showByCustomerTextBox.Text.Replace("'","''");

			// validate input
			if (email == "")
			{
				// user input is invalid, return
				this.showByCustomerError.Visible = true;
				return;
			}

			/* !!! */

		}

		/// <summary>
		/// Show how many of each item are being shipped to a particular city.
		/// </summary>
		protected void CountByCity(object sender, System.EventArgs e)
		{
			// This query is shown on a different page, jump there now!
			Response.Redirect("city.aspx?city=" + this.countByCityTextBox.Text);
		}



	}
}
